//+------------------------------------------------------------------+
//|                                                  SimbaSystem.mq4 |
//|                                      Simba, programmed by Malcik |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

#property copyright "Simba, programmed by Malcik"
#property link      "http://www.forex-tsd.com"

#define MAGICSS  20070129

extern bool    StopAfterNoTrades=false;
extern int     MA_Type=1;             // 1 for SATL, 2 for HULL MA, 3 for JMA
extern int     JMA_HMA_Period=13;     // When using JMA or HMA, set period here
extern double  JMA_Phase=0;           // When using JMA, set phase here
extern bool    UseSATLFilter=true;    // When true, the EA will only go long/short when the price is above/below SATL (or any other MA)
extern bool    AllowReentries=false;  // When true, more than 1 position can be open (reentries at each 10 pips of better price or after retracement of W%R)
extern int     WPR_Period=90;         // W%R period
extern int     ChandDist_Min=35;      // Boundaries of distances of price from Chandelier
extern int     ChandDist_Max=100;     // Self explanatory
extern int     TPPips=355;            // Self explanatory
extern double  LotSize=1;             // Self explanatory
extern int     MaximumRisk=0;         // Integer number of percent of the account you want to risk per trade; if 0, no money management used
extern int     pips=10;               // for reentry, it will buy/sell if it meet criteria and more than 10 pips different than last price ( default = 10 )
extern bool    check_spread=false;    // spread checking feature
extern int     spread_limit = 6;      // maximum allowable spread, default = 6 pips
extern int     wpr_top_limit=-5;      // wpr top limit, default = -5
extern int     wpr_bottom_limit=-95;  // wpr limit, default = -95
extern bool    atr_for_tp=false;      // use Average True Range (daily) for take profit
extern int     atr_period=106;        // self explanatory
extern int     atr_divider=4;         // take profit will be atr_period/atr_divider
extern bool    use_chandelier_if_touched=true; // if set to false, it will exit position if chandelier is touched, otherwise, it will check chandelier every our

extern string  sm="--Trading Hours--";
extern bool    UseTradingHours = true;
extern bool    TradeAsianMarket = true;
extern int     StartHour1 = 0;         // Start trades after time
extern int     StopHour1 = 3;          // Stop trading after time
extern bool    TradeEuropeanMarket = true;
extern int     StartHour2 = 9;         // Start trades after time
extern int     StopHour2 = 11;         // Stop trading after time
extern bool    TradeNewYorkMarket = false;
extern int     StartHour3 = 15;        // Start trades after time
extern int     StopHour3 = 17;         // Stop trading after time

extern string  st6 = "--Profit Controls--";
extern double  StopLoss = 100;         // Maximum pips willing to lose per position.
extern double  Margincutoff = 150;     // Expert will stop trading if equity level decreases to that level
extern string  tsp0 = "--Trailing Stop Types--";
extern string  tsp1 = " 1 = Trail immediately";
extern string  tsp2 = " 2 = Wait to trail";
extern string  tsp3 = " 3 = Uses 3 levels before trail";
extern string  tsp4 = " 4 = Breakeven + Lockin";
extern string  tsp5 = " 5 = Step trail";
extern string  tsp6 = " 6 = EMA trail";
extern string  tsp7 = " 7 = pSAR trail";
extern bool    UseTrailingStop = true;
extern int     TrailingStopType = 4;

extern string  ts2 = "Settings for Type 2";
extern double  TrailingStop = 15;      // Change to whatever number of pips you wish to trail your position with.

extern string  ts3 = "Settings for Type 3";
extern double  FirstMove = 20;        // Type 3  first level pip gain
extern double  FirstStopLoss = 50;    // Move Stop to Breakeven
extern double  SecondMove = 30;       // Type 3 second level pip gain
extern double  SecondStopLoss = 30;   // Move stop to lock is profit
extern double  ThirdMove = 40;        // type 3 third level pip gain
extern double  TrailingStop3 = 20;    // Move stop and trail from there

extern string  ts4 = "Settings for Type 4";
extern double  BreakEven = 37;
extern int     LockInPips = 12;       // Profit Lock in pips

extern string  ts5 = "Settings for Type 5";
extern int     eTrailingStop   = 10;
extern int     eTrailingStep   = 2;

extern string  ts6 = "Settings for Type 6";
extern int     EMATimeFrame    =  30;
extern int     Price           =  0;
extern int     EMAPeriod       = 13;
extern int     EMAShift        =  2;    
extern int     InitialStop     =  0;
 
extern string  ts7 = "Settings for Type 7";
extern double  StepParabolic = 0.02;
extern double  MaxParabolic  = 0.2;
extern int     Interval      = 5;


string order_comment = "SimbaSystemM1";

/*
v1.2.a
======
- check for spread, is spread is bigger than usual, then exit
- change lot calculation from Integer to double
- check minimum/maximum allowable lot from broker and set to minimum/maximum if less/more than minimum/maximum
- fix the ordersend stop loss,for example, for long stop loss, it will 1 point + spread below the chandelier_dn
- make wpr limit for top (-5) & bottom (-95) as extern variable 
  also make the 10 pips as external variable, which is for reentry criteria
  ( maybe usefull for optimisation
- print ordersend error if there is order error
- adding posibility of using atr

v1.2.b
======
- add blocking to spread checking
- move the spread checking to ordersend part, so it will not block entire ea, but blocking ordersend only if spread is crazy
- add use_chandelier_if_touched feature, for stop loss purposes based on if touched or when chandelier change status at the end of the hour

v1.2.c
======
-- add cosmetics tuning Comment and Stop After No Trades

v1.2.d
======
-- modify by Malcik? Please add text.

v1.2.e
======
--  Includes 6 different types of trailing stops
    Code from IgorAD, KimIV and MrPip modified to be functions
--  Added pSAR trailing stop 
todo -- trading hour
*/

datetime LastMinute;
int      LongTrades=0;
int      ShortTrades=0;
double   LastBuyPrice=0;
double   LastSellPrice=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double SATL; //=iCustom(NULL,PERIOD_H4,"SATL",0,1);
   double SATL_Prev; //=iCustom(NULL,PERIOD_H4,"SATL",0,2);
   double Chandelier_Up=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",0,1);
   double Chandelier_Dn=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",1,1);
   double WPR=iWPR(NULL,0,WPR_Period,1);

   int    res;
   double spread;
   
   if (atr_for_tp)
     TPPips = NormalizeDouble((iATR(NULL,PERIOD_D1,atr_period,1)/Point)/atr_divider,0);
     
//----
   if(MA_Type==1)
     {
      SATL=iCustom(NULL,PERIOD_H4,"SATL",0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"SATL",0,2);
     }
   if(MA_Type==2)
     {
      SATL=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,2);
     }
   if(MA_Type==3)
     {
      SATL=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,2);
     }

   LongTrades=0;
   ShortTrades=0;

//+------------------------------------------------------------------+
//| Check for Open Position                                          |
//+------------------------------------------------------------------+

   HandleOpenPositions();

//+------------------------------------------------------------------+
//| Check if OK to make new trades                                   |
//+------------------------------------------------------------------+

   if (OrdersTotal() == 0)
   {
      if (StopAfterNoTrades) { Comment("There are no trades open - Stop After No Trades"); return(0); }
   }
   if(AccountFreeMargin() < Margincutoff) { Comment("EA is stopped, because Margin Cut Off"); return(0);}



   if(OrdersTotal()>0)
   {
      for(int i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)
              {
               if(SATL<SATL_Prev || (Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
              }
            if(OrderType()==OP_SELL)
              {
               if(SATL>SATL_Prev || (Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
              }
           }
        }

      if (use_chandelier_if_touched) {
        for(i=0;i<OrdersTotal();i++)
          {
           if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
             {
              if(OrderType()==OP_BUY)
                {
                 if(OrderStopLoss()<Chandelier_Up-Point-spread)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Up-Point,OrderTakeProfit(),0,Yellow);
                }
              if(OrderType()==OP_SELL)
                {
                 if(OrderStopLoss()>Chandelier_Dn+Point+spread)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Dn+Point+spread,OrderTakeProfit(),0,Green);
                }
             }
          }
      }


      for(i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)LongTrades++;
            if(OrderType()==OP_SELL)ShortTrades++;
           }
        }
     }

   if(LastMinute!=Time[0]) {
      if(AllowReentries)
        {
         if(WPR>=wpr_top_limit)LongTrades=0;
         if(WPR<=wpr_bottom_limit)ShortTrades=0;
        }

      if( LongTrades==0 || 
          (Ask<=LastBuyPrice-pips*Point && AllowReentries)
        )
        {
         if(SATL>SATL_Prev && 
         (Close[0]>=SATL) // || !UseSATLFilter) 
         && Chandelier_Up!=EMPTY_VALUE 
         && Chandelier_Dn==EMPTY_VALUE 
         && Close[0]>=Chandelier_Up+ChandDist_Min*Point 
         && Close[0]<=Chandelier_Up+ChandDist_Max*Point 
         && WPR<=wpr_bottom_limit
         )
           {
           
            spread = Ask-Bid;
            // check the spread, if the spread is not good, then quit the EA
            if (check_spread && spread_limit*Point<spread) {
              Comment("EA is stopped, because spread is more than ",spread_limit, " pips");
              return(0);
            }
            
            if(MaximumRisk!=0)
//                LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/(((Ask-(Chandelier_Up-Point))/Point)*10),2);
                LotSize=NormalizeDouble(MathFloor(AccountFreeMargin()*MaximumRisk/5000)/10,1);              
//                LotSize=NormalizeDouble(MathFloor(AccountEquity()/10000),1)* ;
//                LotSize=NormalizeDouble(MathFloor(AccountFreeMargin()*MaximumRisk/10000)/10,1)*NormalizeDouble(MathFloor(AccountEquity()/5000),1) ;
                
            if(LotSize<MarketInfo(Symbol(),MODE_MINLOT)) // check for minimum lot
              LotSize=MarketInfo(Symbol(),MODE_MINLOT);
            if(LotSize>MarketInfo(Symbol(),MODE_MAXLOT)) // check for maximum lot
              LotSize=MarketInfo(Symbol(),MODE_MAXLOT);
            double buy_price = Ask;
            if (use_chandelier_if_touched)
              res=OrderSend(Symbol(),OP_BUY,LotSize,buy_price,3,Chandelier_Up-Point,buy_price+(TPPips*Point)+spread,order_comment,MAGICSS,0,Blue);
            else
              res=OrderSend(Symbol(),OP_BUY,LotSize,buy_price,3,0,buy_price+(TPPips*Point)+spread,order_comment,MAGICSS,0,Blue);
            if(res > 0) {
              if (OrderSelect(res, SELECT_BY_TICKET, MODE_TRADES)) {
                Print("BUY order opened : ", OrderOpenPrice());          
	           } else {
	             Print("Error opening BUY order : ", ErrorDescription(GetLastError()));
	           }
            } 
            LongTrades++;
            LastBuyPrice=Ask;
           }
        }

      if( ShortTrades==0 || 
          (Bid>=LastSellPrice+pips*Point && AllowReentries)
        )
        {
         if(SATL<SATL_Prev 
            && (Close[0]<=SATL) // || !UseSATLFilter) 
            && Chandelier_Up==EMPTY_VALUE 
            && Chandelier_Dn!=EMPTY_VALUE 
            && Close[0]<=Chandelier_Dn-ChandDist_Min*Point 
            && Close[0]>=Chandelier_Dn-ChandDist_Max*Point
            && WPR>=wpr_top_limit
            )
           {
           
            spread = Ask-Bid;
            // check the spread, if the spread is not good, then quit the EA
            if (check_spread && spread_limit*Point<spread) {
              Comment("EA is stopped, because spread is more than ",spread_limit, " pips");
              return(0);
            } 

            if(MaximumRisk!=0)
//              LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/((((Chandelier_Dn+Point+Point*4)-Bid)/Point)*10),2);
                LotSize=NormalizeDouble(MathFloor(AccountFreeMargin()*MaximumRisk/5000)/10,1);     
//                LotSize=NormalizeDouble(MathFloor(AccountEquity()/5000),1);                       
//                LotSize=NormalizeDouble(MathFloor(AccountFreeMargin()*MaximumRisk/10000)/10,1)*NormalizeDouble(MathFloor(AccountEquity()/5000),1) ;                
            if(LotSize<MarketInfo(Symbol(),MODE_MINLOT)) // check for minimum lot
              LotSize=MarketInfo(Symbol(),MODE_MINLOT);
            if(LotSize>MarketInfo(Symbol(),MODE_MAXLOT)) // check for maximum lot
              LotSize=MarketInfo(Symbol(),MODE_MAXLOT);
            double sell_price = Bid;
            if (use_chandelier_if_touched)
              res=OrderSend(Symbol(),OP_SELL,LotSize,sell_price,3,Chandelier_Dn+Point+spread,sell_price-(TPPips*Point)+spread,order_comment,MAGICSS,0,Red);
            else 
              res=OrderSend(Symbol(),OP_SELL,LotSize,sell_price,3,0,sell_price-(TPPips*Point)+spread,order_comment,MAGICSS,0,Red);
            if(res > 0) {
              if (OrderSelect(res, SELECT_BY_TICKET, MODE_TRADES)) {
                Print("SELL order opened : ", OrderOpenPrice());          
	           } else {
	             Print("Error opening SELL order : ", ErrorDescription(GetLastError()));
	           }
            }
            ShortTrades++;
            LastSellPrice=Bid;
           }
        }

      LastMinute=Time[0];
     }
     spread = Ask-Bid;
     if (StopAfterNoTrades) { Comment("Enabled Stop After No Trades - Balance: ", AccountBalance(), ", Equity: ", AccountEquity(), ", Leverage: ",AccountLeverage(), ", Lots: ",OrderLots(),  ", Spread: ", spread,  ", TP: ", TPPips); }
     else {     Comment("Balance: ", AccountBalance(), ", Equity: ", AccountEquity(), ", Leverage: ",AccountLeverage(), ", Lots: ",OrderLots(),  ", Spread: ", spread,  ", TP: ", TPPips);}


//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Handle Open Positions                                            |
//| Check if any open positions need to be closed or modified        |
//+------------------------------------------------------------------+
int HandleOpenPositions()
{
   int cnt;
   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MAGICSS)  continue;
      
      if(OrderType() == OP_BUY)
      {
         if (UseTrailingStop)
         {
            HandleTrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
         }
      }

      if(OrderType() == OP_SELL)
      {
         if (UseTrailingStop)
         {
            HandleTrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
         }
      }
   }
}

//+------------------------------------------------------------------+
//| HandleTrailingStop                                               |
//| Type 1 moves the stoploss without delay.                         |
//| Type 2 waits for price to move the amount of the trailStop       |
//| before moving stop loss then moves like type 1                   |
//| Type 3 uses up to 3 levels for trailing stop                     |
//|      Level 1 Move stop to 1st level                              |
//|      Level 2 Move stop to 2nd level                              |
//|      Level 3 Trail like type 1 by fixed amount other than 1      |
//| Type 4 Move stop to breakeven + Lockin, no trail                 |
//| Type 5 uses steps for 1, every step pip move moves stop 1 pip    |
//| Type 6 Uses EMA to set trailing stop                             |
//+------------------------------------------------------------------+
int HandleTrailingStop(int type, int ticket, double op, double os, double tp)
{
   switch (TrailingStopType)
   {
     case 1 : Immediate_TrailingStop (type, ticket, op, os, tp);
              break;
     case 2 : Delayed_TrailingStop (type, ticket, op, os, tp);
              break;
     case 3 : ThreeLevel_TrailingStop (type, ticket, op, os, tp);
              break;
     case 4 : BreakEven_TrailingStop (type, ticket, op, os, tp);
              break;
	  case 5 : eTrailingStop (type, ticket, op, os, tp);
              break;
	  case 6 : EMA_TrailingStop (type, ticket, op, os, tp);
              break;
	  case 7 : pSAR_TrailingStop (type, ticket, op, os, tp);
              break;
	}
   return(0);
}

//+------------------------------------------------------------------+
//|                                       Immediate_TrailingStop.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by MrPip,robydoby314@yahoo.com   |
//|                                                                  |   
//| Moves the stoploss without delay.                                |
//+------------------------------------------------------------------+
void Immediate_TrailingStop(int type, int ticket, double op, double os, double tp)
{

   int digits;
   double pt, pBid, pAsk, pp, BuyStop, SellStop;

   pp = MarketInfo(Symbol(), MODE_POINT);
   digits = MarketInfo(Symbol( ), MODE_DIGITS);
   
   if (type==OP_BUY)
   {
     pBid = MarketInfo(Symbol(), MODE_BID);
     pt = StopLoss * pp;
     if(pBid-os > pt)
     {
       BuyStop = pBid - pt;
       if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
		 BuyStop = ValidStopLoss(OP_BUY,pBid, BuyStop);   
       if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
       if (os < BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
		 return;
	  }
   }
   if (type==OP_SELL)
   {
     pAsk = MarketInfo(Symbol(), MODE_ASK);
     pt = StopLoss * pp;
     if(os - pAsk > pt)
     {
       SellStop = pAsk + pt;
       if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
       SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);  
       if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
       if (os > SellStop) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
		 return;
     }
   }   
}

//+------------------------------------------------------------------+
//|                                         Delayed_TrailingStop.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by MrPip,robydoby314@yahoo.com   |
//|                                                                  |   
//| Waits for price to move the amount of the TrailingStop           |
//| Moves the stoploss pip for pip after delay.                      |
//+------------------------------------------------------------------+
void Delayed_TrailingStop(int type, int ticket, double op, double os, double tp)
{
   int digits;
   double pt, pBid, pAsk, pp, BuyStop, SellStop;

   pp = MarketInfo(Symbol(), MODE_POINT);
   pt = TrailingStop * pp;
   digits = MarketInfo(Symbol(), MODE_DIGITS);
   
   if (type==OP_BUY)
   {
     pBid = MarketInfo(Symbol(), MODE_BID);
     BuyStop = pBid - pt;
     if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
	  BuyStop = ValidStopLoss(OP_BUY,pBid, BuyStop);   
     if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
     if (pBid-op > pt && os < BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
	  return;
   }
   if (type==OP_SELL)
   {
     pAsk = MarketInfo(Symbol(), MODE_ASK);
     pt = TrailingStop * pp;
     SellStop = pAsk + pt;
     if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
     SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);  
     if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
     if (op - pAsk > pt && os > SellStop) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
	  return;
   }   
}

//+------------------------------------------------------------------+
//|                                      ThreeLevel_TrailingStop.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by MrPip,robydoby314@yahoo.com   |   
//|                                                                  |
//| Uses up to 3 levels for trailing stop                            |
//|      Level 1 Move stop to 1st level                              |
//|      Level 2 Move stop to 2nd level                              |
//|      Level 3 Trail like type 1 by fixed amount other than 1      |
//+------------------------------------------------------------------+
void ThreeLevel_TrailingStop(int type, int ticket, double op, double os, double tp)
{

   int digits;
   double pBid, pAsk, pp, BuyStop, SellStop;

   pp = MarketInfo(Symbol(), MODE_POINT);
   digits = MarketInfo(Symbol(), MODE_DIGITS) ;

   if (type == OP_BUY)
   {
      pBid = MarketInfo(Symbol(), MODE_BID);
      if (pBid - op > FirstMove * pp)
      {
         BuyStop = op + FirstMove*pp - FirstStopLoss * pp;
         if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
		   BuyStop = ValidStopLoss(OP_BUY, pBid, BuyStop);   
         if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
         if (os < BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
      }
              
      if (pBid - op > SecondMove * pp)
      {
         BuyStop = op + SecondMove*pp - SecondStopLoss * pp;
         if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
		   BuyStop = ValidStopLoss(OP_BUY, pBid, BuyStop);   
         if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
         if (os < BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
      }
                
      if (pBid - op > ThirdMove * pp)
      {
         BuyStop = pBid  - ThirdMove*pp;
         if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
		   BuyStop = ValidStopLoss(OP_BUY, pBid, BuyStop);   
         if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
         if (os < BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
      }
   }
       
    if (type ==  OP_SELL)
    {
        pAsk = MarketInfo(Symbol(), MODE_ASK);
        if (op - pAsk > FirstMove * pp)
        {
           SellStop = op - FirstMove * pp + FirstStopLoss * pp;
           if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
		     SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);   
           if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
           if (os > SellStop) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
        }
        if (op - pAsk > SecondMove * pp)
        {
           SellStop = op - SecondMove * pp + SecondStopLoss * pp;
           if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
		     SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);   
           if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
           if (os > SellStop) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
        }
        if (op - pAsk > ThirdMove * pp)
        {
           SellStop = pAsk + ThirdMove * pp;               
           if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
		     SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);   
           if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
           if (os > SellStop) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
        }
    }
}

//+------------------------------------------------------------------+
//|                                           BreakEvenExpert_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
void BreakEven_TrailingStop(int type, int ticket, double op, double os, double tp)
{

   int digits;
   double pBid, pAsk, pp, BuyStop, SellStop;

   pp = MarketInfo(Symbol(), MODE_POINT);
   digits = MarketInfo(Symbol(), MODE_DIGITS);
   
  if (type==OP_BUY)
  {
    pBid = MarketInfo(Symbol(), MODE_BID);
    if ( pBid-op > pp*BreakEven ) 
    {
       BuyStop = op + LockInPips * pp;
       if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
		 BuyStop = ValidStopLoss(OP_BUY,pBid, BuyStop);   
       if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
       if (os < BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
		 return;
	 }
  }
  if (type==OP_SELL)
  {
    pAsk = MarketInfo(Symbol(), MODE_ASK);
    if ( op - pAsk > pp*BreakEven ) 
    {
       SellStop = op - LockInPips * pp;
       if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
       SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);  
       if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
       if (os > SellStop) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
		 return;
    }
  }   

}

//+------------------------------------------------------------------+
//|                                                   e-Trailing.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//| 12.09.2005  Trailing Stop       |
//|                                          |
//+------------------------------------------------------------------+
void eTrailingStop(int type, int ticket, double op, double os, double tp)
{
  int digits;
  double pBid, pAsk, pp, BuyStop, SellStop;

  pp = MarketInfo(Symbol(), MODE_POINT);
  digits = MarketInfo(Symbol(), MODE_DIGITS) ;
  if (type==OP_BUY)
  {
    pBid = MarketInfo(Symbol(), MODE_BID);
    if ((pBid-op)>eTrailingStop*pp)
    {
      if (os<pBid-(eTrailingStop+eTrailingStep-1)*pp)
      {
        BuyStop = pBid-eTrailingStop*pp;
        if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
		  BuyStop = ValidStopLoss(OP_BUY, pBid, BuyStop);   
        if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
        ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
        return;
      }
    }
  }
  if (type==OP_SELL)
  {
    pAsk = MarketInfo(Symbol(), MODE_ASK);
    if (op - pAsk > eTrailingStop*pp)
    {
      if (os > pAsk + (eTrailingStop + eTrailingStep-1)*pp || os==0)
      {
        SellStop = pAsk + eTrailingStop * pp;
        if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
        SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);  
        if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
        ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
        return;
      }
    }
  }

}

//+------------------------------------------------------------------+
//|                                           EMATrailingStop_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
void EMA_TrailingStop(int type, int ticket, double op, double os, double tp)
{
   int digits;
   double pBid, pAsk, pp, BuyStop, SellStop, ema;

   pp = MarketInfo(Symbol(), MODE_POINT);
   digits = MarketInfo(Symbol(), MODE_DIGITS) ;
   ema = iMA(Symbol(),EMATimeFrame,EMAPeriod,0,MODE_EMA,Price,EMAShift);
   
   if (type==OP_BUY) 
   {
	   BuyStop = ema;
      pBid = MarketInfo(Symbol(),MODE_BID);
		if(os == 0 && InitialStop>0 ) BuyStop = pBid-InitialStop*pp;
		if (digits > 0) BuyStop = NormalizeDouble(SellStop, digits); 
		BuyStop = ValidStopLoss(OP_BUY, pBid, BuyStop);   
		if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits);
		Print("MA=",ema," BuyStop=",BuyStop);
		if ((op <= BuyStop && BuyStop > os) || os==0) 
		{
          ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
			 return;
      }
   }   

   if (type==OP_SELL)
   {
	   SellStop = ema;
      pAsk = MarketInfo(Symbol(),MODE_ASK);
      if (os==0 && InitialStop > 0) SellStop = pAsk+InitialStop*pp;
		if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
		SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);
		if (digits > 0) SellStop = NormalizeDouble(SellStop, digits);
      Print("MA=",ema," SellStop=",SellStop);   
      if( (op >= SellStop && os > SellStop) || os==0) 
      {
          ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
			 return;
      }
   }
}

//+------------------------------------------------------------------+
//|                                                b-TrailingSAR.mqh |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|    21.11.2005      .           |
//|        start                |
//|  if (UseTrailing) TrailingPositions();                           |
//+------------------------------------------------------------------+
void pSAR_TrailingStop(int type, int ticket, double op, double os, double tp)
{
   int digits;
   double pBid, pAsk, pp, BuyStop, SellStop, spr;
   double sar1, sar2;
  
   pp = MarketInfo(Symbol(), MODE_POINT);
   digits = MarketInfo(Symbol(), MODE_DIGITS) ;
   pBid = MarketInfo(Symbol(), MODE_BID);
   pAsk = MarketInfo(Symbol(), MODE_ASK);
   sar1=iSAR(NULL, 0, StepParabolic, MaxParabolic, 1);
   sar2=iSAR(NULL, 0, StepParabolic, MaxParabolic, 2);
   spr = pAsk - pBid;
   if (digits > 0) spr = NormalizeDouble(spr, digits); 
   
   if (type==OP_BUY)
   {
     pBid = MarketInfo(Symbol(), MODE_BID);
     if (sar2 < sar1)
     {
        BuyStop = sar1-Interval*pp;
        if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
	     BuyStop = ValidStopLoss(OP_BUY, pBid, BuyStop);   
        if (digits > 0) BuyStop = NormalizeDouble(BuyStop, digits); 
        if (os<BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
     }
   }
   if (type==OP_SELL)
   {
     if (sar2 > sar1)
     {
        SellStop = sar1 + Interval * pp + spr;
        if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
	     SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);   
        if (digits > 0) SellStop = NormalizeDouble(SellStop, digits); 
        if (os>SellStop || os==0) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
     }
   }
}

double ValidStopLoss(int type, double price, double SL)
{
   double minstop, pp;
   
   pp = MarketInfo(Symbol(), MODE_POINT);
   minstop = MarketInfo(Symbol(),MODE_STOPLEVEL);
   if (type == OP_BUY)
   {
		 if((price - SL) < minstop*pp) SL = price - minstop*pp;
   }
   if (type == OP_SELL)
   {
       if((SL-price) < minstop*pp)  SL = price + minstop*pp;  
   }
   return(SL);   
}

int ModifyOrder(int ord_ticket,double op, double price,double tp, color mColor)
{
    int CloseCnt, err;
    
    CloseCnt=0;
    while (CloseCnt < 3)
    {
       if (OrderModify(ord_ticket,op,price,tp,0,mColor))
       {
         CloseCnt = 3;
       }
       else
       {
          err=GetLastError();
          Print(CloseCnt," Error modifying order : (", err , ") " + ErrorDescription(err));
         if (err>0) CloseCnt++;
       }
    }
}

